#include <avr/io.h>
#include <avr/interrupt.h>

void InitHardware(void)
{
    DDRB = (1<<PB0); /* pin connected to LED is output pin */

    /* initialize timer 1 */
    TCCR1B = (1<<CS11) | (1<<CS10); /* prescaler = clk/64 */
}

int main(void)
{
    InitHardware();
    while(1) {
        // DoSomeBackgroundStuff();
        if (TIFR & (1<<TOV1)) {
            TIFR |= (1<<TOV1); /* clear pending flag by
                                  writing a logical 1 */

            PORTB ^= (1<<PB0); /* toggle LED */
            // DoSomePeriodicalStuff();
        }
    }
}