#ifdef PRINT_RESULTS_ON_PC
#   include <stdio.h>
#endif

#include <math.h>
#include <limits.h>
#include "Observation.h"
#include "sqrtFast.h"

volatile unsigned short result, iGETmax, iGETmin;
unsigned short GETmax = 0;
unsigned short GETmin = UINT_MAX;
unsigned long GETavg = 0;

int main(void)
{
    unsigned short i = 0;
    InitObservation();
    do {
        StartObservation();
        result = sqrtFast(i);
#ifdef PRINT_RESULTS_ON_PC
        printf("%d\t%d\t%d\n", i, result, (unsigned short) sqrt(i));
#endif
        StopObservation();
        GETavg += GetGrossExecutionTime();
        if(GetGrossExecutionTime() > GETmax) {
            GETmax = GetGrossExecutionTime();
            iGETmax = i;
        }
        if(GetGrossExecutionTime() < GETmin) {
            GETmin = GetGrossExecutionTime();
            iGETmin = i;
        }
        i++;
    } while (i != 0);
    GETavg >>= 16;
    return 0;
}