#ifndef OBSERVATION_H_
#define OBSERVATION_H_

#ifdef PRINT_RESULTS_ON_PC
#   define InitObservation()
#   define StartObservation()
#   define StopObservation()
#   define GetGrossExecutionTime() (0u)
#else

#   include <avr/io.h>
#   include <avr/interrupt.h>

extern unsigned short startTime;
extern unsigned short grossExecutionTime;

void InitObservation(void);

inline unsigned short SafeReadTCNT1(void)
{
    unsigned char sreg;
    unsigned short retVal;

    sreg = SREG; // save interrupt lock status
    cli(); // disable all interrupts
    retVal = TCNT1;
    SREG = sreg; // restore interrupt lock status
    return retVal;
}

inline void StartObservation(void)
{
    startTime = SafeReadTCNT1();
}

inline void StopObservation(void)
{
    grossExecutionTime = SafeReadTCNT1() - startTime;
}

inline unsigned short GetGrossExecutionTime(void)
{
    return grossExecutionTime;
}
#endif /* else PRINT_RESULTS_ON_PC */

#endif /* OBSERVATION_H_ */